﻿// $Id: QuestionContainer.cs 10 2008-02-29 15:58:02Z mcartoixa $
/*
 *  Copyright (C) 2007 NourY Solutions
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library. If not, see <http://www.gnu.org/licenses/>.
 *
 */
/*! \file
 * \brief Definition of \c Salamanca.DataActivities.UI.QuestionContainer.
 *
 * \author $Author: mcartoixa $
 * \date $Date: 2008-02-29 16:58:02 +0100 (ven., 29 févr. 2008) $
 * \version $Revision: 10 $
 */

using System;
using System.Collections.Generic;
using System.Text;

namespace Salamanca.DataActivities.UI
{



    ///////////////////////////////////////////////////////////////////////////
    ///
    /// <summary>A question container interface.</summary>
    ///
    ///////////////////////////////////////////////////////////////////////////

    public interface IQuestionContainer:
        IDisposable
    {
        /// <summary>Adds the specified <see cref="IQuestion" /> to the container.</summary>
        void Add(IQuestion question);
        /// <summary>Removes the specified <see cref="IQuestion" /> from the container.</summary>
        void Remove(IQuestion question);

        /// <summary>Gets the list of questions contained.</summary>
        IList<IQuestion> Questions
        {
            get;
        }
    }
}
