// $Id: Category.Model.cs 17434 2008-12-01 12:48:12Z unknown $
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Globalization;
using System.Xml.Serialization;
using Salamanca.DataAccess;
using Salamanca.DataAccess.Collections;
using Salamanca.DataRules;
#if (!NET_CF)
using System.Diagnostics.CodeAnalysis;
#endif

namespace Northwind.DomainModel
{

    /// <summary />
    partial interface ICategoryContainer
    {
        /// <summary />
      Category Category
        {
            get;
            set;
        }

    }

    /// <summary />
    partial interface ICategoryMapper
    {

        /// <summary />
        Category Find(Category.PrimaryKey key, DataMapperCollection dataMappers);
        /// <summary />
        DomainEntityKeyedCollection<Category> FindAll(DataMapperCollection dataMappers);

    }

    /// <summary />
    partial class Category
    {

        /// <summary />
        partial class PrimaryKey
        {
            /// <summary />
            public static implicit operator PrimaryKey(int key)
            {
                return new PrimaryKey(key);
            }

            /// <summary />
            public static explicit operator int(PrimaryKey key)
            {
                return key.Value;
            }

        }

        /// <summary />
        partial class DataTransfer
        {
            /// <summary />
#if (!NET_CF)
            [SuppressMessage("Microsoft.Design", "CA1051:DoNotDeclareVisibleInstanceFields")]
#endif
            public int CategoryID;
            /// <summary />
#if (!NET_CF)
            [SuppressMessage("Microsoft.Design", "CA1051:DoNotDeclareVisibleInstanceFields")]
#endif
            public string CategoryName;
            /// <summary />
#if (!NET_CF)
            [SuppressMessage("Microsoft.Design", "CA1051:DoNotDeclareVisibleInstanceFields")]
#endif
            public string Description;

            /// <summary />
            public object Clone()
            {
                return MemberwiseClone();
            }

        }

        /// <summary />
        protected override Category.PrimaryKey CreateId()
        {
            return new Category.PrimaryKey(Data.CategoryID);
        }

        /// <summary />
        internal Category.PrimaryKey GetId()
        {
            return Id;
        }

        /// <summary />
        internal void SetId(int id)
        {
            Data.CategoryID=id;
        }


        /// <summary />
#if (!NET_CF)
        [DataObjectMethod(DataObjectMethodType.Select, false)]
#endif
        public static Category Find(Category.PrimaryKey key, DataMapperCollection dataMappers)
        {
            return ((ICategoryMapper)dataMappers[typeof(Category)]).Find(key, dataMappers);
        }

        /// <summary />
#if (!NET_CF)
        [DataObjectMethod(DataObjectMethodType.Select, true)]
#endif
        public static IList<Category> FindAll(DataMapperCollection dataMappers)
        {
            return ((ICategoryMapper)dataMappers[typeof(Category)]).FindAll(dataMappers);
        }

        /// <summary />
        internal bool InternalIsNew
        {
            get
            {
                return IsNew;
            }
        }

        /// <summary />
        private string _CategoryNameProperty
        {
            get
            {
                Load(true);
                return Data.CategoryName;
            }
            set
            {
                if (Data.CategoryName!=value)
                {
                    Data.CategoryName=value;
                }
            }
        }

        /// <summary />
        private string _DescriptionProperty
        {
            get
            {
                Load(true);
                return Data.Description;
            }
            set
            {
                if (Data.Description!=value)
                {
                    Data.Description=value;
                }
            }
        }


        /// <summary />
        public static readonly IdentityMap<Category.PrimaryKey, Category> IdentityMap=new IdentityMap<Category.PrimaryKey, Category>();

    }

}
