﻿// $Id: ProductMapper.cs 17434 2008-12-01 12:48:12Z unknown $
/*! \file
 * \brief Definition of Northwind.DomainModel.Data.ProductMapper.
 *
 * \author $Author: unknown $
 * \date $Date: 2008-12-01 04:48:12 -0800 (周一, 01 十二月 2008) $
 * \version $Revision: 17434 $
 */

using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Common;
using Salamanca.DataAccess;
using Salamanca.DataAccess.Collections;
using Salamanca.DataAccess.Data;

namespace Northwind.DomainModel.Data
{



    ///////////////////////////////////////////////////////////////////////////
    ///
    /// <summary />
    ///
    ///////////////////////////////////////////////////////////////////////////

    public partial class ProductMapper:
        DataMapper<Product, Product.PrimaryKey, Product.DataTransfer>,
        IProductMapper
    {

        /// <summary />
        public ProductMapper(DbConnection connection, ICacheManager cacheManager):
            base(connection, DomainEntityCreator.CreateDefault<Product>(), cacheManager)
        {
            _ParameterBuilder=new ParameterBuilder(connection);
        }

        /// <summary />
        public DomainEntityKeyedCollection<Product> FindAll(DataMapperCollection dataMappers)
        {
          return _FindAll(dataMappers);
        }

        /// <summary />
        protected override IList<IDbCommand> CreateSelectCommands(Product.PrimaryKey key)
        {
            return CreateSelectCommands(Connection, ParameterBuilder, key);
        }

        /// <summary />
        protected override IList<IDbCommand> CreateDeleteCommands(Product.DataTransfer data)
        {
            return CreateDeleteCommands(Connection, ParameterBuilder, (Product.DataTransfer)data);
        }

        /// <summary />
        protected override IList<IDbCommand> CreateInsertCommands(Product.DataTransfer data)
        {
            return CreateInsertCommands(Connection, ParameterBuilder, (Product.DataTransfer)data);
        }

        /// <summary />
        protected override IList<IDbCommand> CreateUpdateCommands(Product.DataTransfer data)
        {
            return CreateUpdateCommands(Connection, ParameterBuilder, (Product.DataTransfer)data);
        }

        /// <summary />
        protected override Product.DataTransfer GetDataTransferObject(IList<IDataRecord> records)
        {
          return _GetDataTransferObject(records);
        }

        /// <summary />
        protected override void OnInserted(Product domainModel, IList<IDbCommand> commands)
        {
            domainModel.SetId(Utils.GetLastId(Connection, commands));

            base.OnInserted(domainModel, commands);
        }

        /// <summary />
        internal static IList<IDbCommand> CreateSelectCommands(IDbConnection connection, ParameterBuilder parameterBuilder, Product.PrimaryKey key)
        {
            return new IDbCommand[] { _CreateSelectCommand(connection, parameterBuilder, key) };
        }

        /// <summary />
        internal static IList<IDbCommand> CreateDeleteCommands(IDbConnection connection, ParameterBuilder parameterBuilder, Product.DataTransfer data)
        {
            return new IDbCommand[] { _CreateDeleteCommand(connection, parameterBuilder, (Product.DataTransfer)data) };
        }

        /// <summary />
        internal static IList<IDbCommand> CreateInsertCommands(IDbConnection connection, ParameterBuilder parameterBuilder, Product.DataTransfer data)
        {
            return new IDbCommand[] { _CreateInsertCommand(connection, parameterBuilder, (Product.DataTransfer)data) };
        }

        /// <summary />
        internal static IList<IDbCommand> CreateUpdateCommands(IDbConnection connection, ParameterBuilder parameterBuilder, Product.DataTransfer data)
        {
            return new IDbCommand[] { _CreateUpdateCommand(connection, parameterBuilder, (Product.DataTransfer)data) };
        }

    }
}
