﻿// $Id: SupplierMapper.cs 17434 2008-12-01 12:48:12Z unknown $
/*! \file
 * \brief Definition of Northwind.DomainModel.Data.SupplierMapper.
 *
 * \author $Author: unknown $
 * \date $Date: 2008-12-01 04:48:12 -0800 (周一, 01 十二月 2008) $
 * \version $Revision: 17434 $
 */

using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Common;
using Salamanca.DataAccess;
using Salamanca.DataAccess.Collections;
using Salamanca.DataAccess.Data;

namespace Northwind.DomainModel.Data
{



    ///////////////////////////////////////////////////////////////////////////
    ///
    /// <summary />
    ///
    ///////////////////////////////////////////////////////////////////////////

    public partial class SupplierMapper:
        DataMapper<Supplier, Supplier.PrimaryKey, Supplier.DataTransfer>,
        ISupplierMapper
    {

        /// <summary />
        public SupplierMapper(DbConnection connection, ICacheManager cacheManager):
            base(connection, DomainEntityCreator.CreateDefault<Supplier>(), cacheManager)
        {
            _ParameterBuilder=new ParameterBuilder(connection);
        }

        /// <summary />
        public DomainEntityKeyedCollection<Supplier> FindAll(DataMapperCollection dataMappers)
        {
          return _FindAll(dataMappers);
        }

        /// <summary />
        protected override IList<IDbCommand> CreateSelectCommands(Supplier.PrimaryKey key)
        {
            return CreateSelectCommands(Connection, ParameterBuilder, key);
        }

        /// <summary />
        protected override IList<IDbCommand> CreateDeleteCommands(Supplier.DataTransfer data)
        {
            return CreateDeleteCommands(Connection, ParameterBuilder, (Supplier.DataTransfer)data);
        }

        /// <summary />
        protected override IList<IDbCommand> CreateInsertCommands(Supplier.DataTransfer data)
        {
            return CreateInsertCommands(Connection, ParameterBuilder, (Supplier.DataTransfer)data);
        }

        /// <summary />
        protected override IList<IDbCommand> CreateUpdateCommands(Supplier.DataTransfer data)
        {
            return CreateUpdateCommands(Connection, ParameterBuilder, (Supplier.DataTransfer)data);
        }

        /// <summary />
        protected override Supplier.DataTransfer GetDataTransferObject(IList<IDataRecord> records)
        {
          return _GetDataTransferObject(records);
        }

        /// <summary />
        protected override void OnInserted(Supplier domainModel, IList<IDbCommand> commands)
        {
            domainModel.SetId(Utils.GetLastId(Connection, commands));

            base.OnInserted(domainModel, commands);
        }

        /// <summary />
        internal static IList<IDbCommand> CreateSelectCommands(IDbConnection connection, ParameterBuilder parameterBuilder, Supplier.PrimaryKey key)
        {
            return new IDbCommand[] { _CreateSelectCommand(connection, parameterBuilder, key) };
        }

        /// <summary />
        internal static IList<IDbCommand> CreateDeleteCommands(IDbConnection connection, ParameterBuilder parameterBuilder, Supplier.DataTransfer data)
        {
            return new IDbCommand[] { _CreateDeleteCommand(connection, parameterBuilder, (Supplier.DataTransfer)data) };
        }

        /// <summary />
        internal static IList<IDbCommand> CreateInsertCommands(IDbConnection connection, ParameterBuilder parameterBuilder, Supplier.DataTransfer data)
        {
            return new IDbCommand[] { _CreateInsertCommand(connection, parameterBuilder, (Supplier.DataTransfer)data) };
        }

        /// <summary />
        internal static IList<IDbCommand> CreateUpdateCommands(IDbConnection connection, ParameterBuilder parameterBuilder, Supplier.DataTransfer data)
        {
            return new IDbCommand[] { _CreateUpdateCommand(connection, parameterBuilder, (Supplier.DataTransfer)data) };
        }

    }
}
