﻿// $Id: ShipperMapper.cs 17434 2008-12-01 12:48:12Z unknown $
/*! \file
 * \brief Definition of Northwind.DomainModel.EnterpriseLibrary.ShipperMapper.
 *
 * \author $Author: unknown $
 * \date $Date: 2008-12-01 04:48:12 -0800 (周一, 01 十二月 2008) $
 * \version $Revision: 17434 $
 */

using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
using Salamanca.DataAccess;
using Salamanca.DataAccess.Collections;
using Salamanca.DataAccess.EnterpriseLibrary.Data;

namespace Northwind.DomainModel.EnterpriseLibrary
{



    ///////////////////////////////////////////////////////////////////////////
    ///
    /// <summary />
    ///
    ///////////////////////////////////////////////////////////////////////////

    public partial class ShipperMapper:
        DataMapper<Shipper, Shipper.PrimaryKey, Shipper.DataTransfer>,
        IShipperMapper
    {

        /// <summary />
        public ShipperMapper(Database database, ICacheManager cacheManager):
            base(database, DomainEntityCreator.CreateDefault<Shipper>(), cacheManager)
        {
            _ParameterBuilder=new Salamanca.DataAccess.Data.ParameterBuilder(database.CreateConnection());
        }

        /// <summary />
        public DomainEntityKeyedCollection<Shipper> FindAll(DataMapperCollection dataMappers)
        {
            return _FindAll(dataMappers);
        }

        /// <summary />
        protected override IList<DbCommand> CreateSelectCommands(Shipper.PrimaryKey key)
        {
            return CreateSelectCommands(Database, ParameterBuilder, key);
        }

        /// <summary />
        protected override IList<DbCommand> CreateDeleteCommands(Shipper.DataTransfer data)
        {
            return CreateDeleteCommands(Database, ParameterBuilder, (Shipper.DataTransfer)data);
        }

        /// <summary />
        protected override IList<DbCommand> CreateInsertCommands(Shipper.DataTransfer data)
        {
            return CreateInsertCommands(Database, ParameterBuilder, (Shipper.DataTransfer)data);
        }

        /// <summary />
        protected override IList<DbCommand> CreateUpdateCommands(Shipper.DataTransfer data)
        {
            return CreateUpdateCommands(Database, ParameterBuilder, (Shipper.DataTransfer)data);
        }

        /// <summary />
        protected override Shipper.DataTransfer GetDataTransferObject(IList<IDataRecord> records)
        {
          return _GetDataTransferObject(records);
        }

        /// <summary />
        protected override void OnInserted(Shipper domainModel, IList<DbCommand> commands)
        {
            domainModel.SetId(Utils.GetLastId(Database, commands));

            base.OnInserted(domainModel, commands);
        }

        /// <summary />
        internal static IList<DbCommand> CreateSelectCommands(Database database, Salamanca.DataAccess.Data.ParameterBuilder parameterBuilder, Shipper.PrimaryKey key)
        {
            return new DbCommand[] { _CreateSelectCommand(database, parameterBuilder, key) };
        }

        /// <summary />
        internal static IList<DbCommand> CreateDeleteCommands(Database database, Salamanca.DataAccess.Data.ParameterBuilder parameterBuilder, Shipper.DataTransfer data)
        {
            return new DbCommand[] { _CreateDeleteCommand(database, parameterBuilder, (Shipper.DataTransfer)data) };
        }

        /// <summary />
        internal static IList<DbCommand> CreateInsertCommands(Database database, Salamanca.DataAccess.Data.ParameterBuilder parameterBuilder, Shipper.DataTransfer data)
        {
            return new DbCommand[] { _CreateInsertCommand(database, parameterBuilder, (Shipper.DataTransfer)data) };
        }

        /// <summary />
        internal static IList<DbCommand> CreateUpdateCommands(Database database, Salamanca.DataAccess.Data.ParameterBuilder parameterBuilder, Shipper.DataTransfer data)
        {
            return new DbCommand[] { _CreateUpdateCommand(database, parameterBuilder, (Shipper.DataTransfer)data) };
        }

    }
}
