// $Id: Supplier.Model.cs 17434 2008-12-01 12:48:12Z unknown $
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Globalization;
using System.Xml.Serialization;
using Salamanca.DataAccess;
using Salamanca.DataAccess.Collections;
using Salamanca.DataRules;
#if (!NET_CF)
using System.Diagnostics.CodeAnalysis;
#endif

namespace Northwind.DomainModel
{

    /// <summary />
    partial interface ISupplierContainer
    {
        /// <summary />
      Supplier Supplier
        {
            get;
            set;
        }

    }

    /// <summary />
    partial interface ISupplierMapper
    {

        /// <summary />
        Supplier Find(Supplier.PrimaryKey key, DataMapperCollection dataMappers);
        /// <summary />
        DomainEntityKeyedCollection<Supplier> FindAll(DataMapperCollection dataMappers);

    }

    /// <summary />
    partial class Supplier
    {

        /// <summary />
        partial class PrimaryKey
        {
            /// <summary />
            public static implicit operator PrimaryKey(int key)
            {
                return new PrimaryKey(key);
            }

            /// <summary />
            public static explicit operator int(PrimaryKey key)
            {
                return key.Value;
            }

        }

        /// <summary />
        partial class DataTransfer
        {
            /// <summary />
#if (!NET_CF)
            [SuppressMessage("Microsoft.Design", "CA1051:DoNotDeclareVisibleInstanceFields")]
#endif
            public int SupplierID;
            /// <summary />
#if (!NET_CF)
            [SuppressMessage("Microsoft.Design", "CA1051:DoNotDeclareVisibleInstanceFields")]
#endif
            public string CompanyName;
            /// <summary />
#if (!NET_CF)
            [SuppressMessage("Microsoft.Design", "CA1051:DoNotDeclareVisibleInstanceFields")]
#endif
            public string ContactName;
            /// <summary />
#if (!NET_CF)
            [SuppressMessage("Microsoft.Design", "CA1051:DoNotDeclareVisibleInstanceFields")]
#endif
            public string ContactTitle;
            /// <summary />
#if (!NET_CF)
            [SuppressMessage("Microsoft.Design", "CA1051:DoNotDeclareVisibleInstanceFields")]
#endif
            public string Address;
            /// <summary />
#if (!NET_CF)
            [SuppressMessage("Microsoft.Design", "CA1051:DoNotDeclareVisibleInstanceFields")]
#endif
            public string City;
            /// <summary />
#if (!NET_CF)
            [SuppressMessage("Microsoft.Design", "CA1051:DoNotDeclareVisibleInstanceFields")]
#endif
            public string Region;
            /// <summary />
#if (!NET_CF)
            [SuppressMessage("Microsoft.Design", "CA1051:DoNotDeclareVisibleInstanceFields")]
#endif
            public string PostalCode;
            /// <summary />
#if (!NET_CF)
            [SuppressMessage("Microsoft.Design", "CA1051:DoNotDeclareVisibleInstanceFields")]
#endif
            public string Country;
            /// <summary />
#if (!NET_CF)
            [SuppressMessage("Microsoft.Design", "CA1051:DoNotDeclareVisibleInstanceFields")]
#endif
            public string Phone;
            /// <summary />
#if (!NET_CF)
            [SuppressMessage("Microsoft.Design", "CA1051:DoNotDeclareVisibleInstanceFields")]
#endif
            public string Fax;
            /// <summary />
#if (!NET_CF)
            [SuppressMessage("Microsoft.Design", "CA1051:DoNotDeclareVisibleInstanceFields")]
#endif
            public string HomePage;

            /// <summary />
            public object Clone()
            {
                return MemberwiseClone();
            }

        }

        /// <summary />
        protected override Supplier.PrimaryKey CreateId()
        {
            return new Supplier.PrimaryKey(Data.SupplierID);
        }

        /// <summary />
        internal Supplier.PrimaryKey GetId()
        {
            return Id;
        }

        /// <summary />
        internal void SetId(int id)
        {
            Data.SupplierID=id;
        }


        /// <summary />
#if (!NET_CF)
        [DataObjectMethod(DataObjectMethodType.Select, false)]
#endif
        public static Supplier Find(Supplier.PrimaryKey key, DataMapperCollection dataMappers)
        {
            return ((ISupplierMapper)dataMappers[typeof(Supplier)]).Find(key, dataMappers);
        }

        /// <summary />
#if (!NET_CF)
        [DataObjectMethod(DataObjectMethodType.Select, true)]
#endif
        public static IList<Supplier> FindAll(DataMapperCollection dataMappers)
        {
            return ((ISupplierMapper)dataMappers[typeof(Supplier)]).FindAll(dataMappers);
        }

        /// <summary />
        internal bool InternalIsNew
        {
            get
            {
                return IsNew;
            }
        }

        /// <summary />
        private string _CompanyNameProperty
        {
            get
            {
                Load(true);
                return Data.CompanyName;
            }
            set
            {
                if (Data.CompanyName!=value)
                {
                    Data.CompanyName=value;
                }
            }
        }

        /// <summary />
        private string _ContactNameProperty
        {
            get
            {
                Load(true);
                return Data.ContactName;
            }
            set
            {
                if (Data.ContactName!=value)
                {
                    Data.ContactName=value;
                }
            }
        }

        /// <summary />
        private string _ContactTitleProperty
        {
            get
            {
                Load(true);
                return Data.ContactTitle;
            }
            set
            {
                if (Data.ContactTitle!=value)
                {
                    Data.ContactTitle=value;
                }
            }
        }

        /// <summary />
        private string _AddressProperty
        {
            get
            {
                Load(true);
                return Data.Address;
            }
            set
            {
                if (Data.Address!=value)
                {
                    Data.Address=value;
                }
            }
        }

        /// <summary />
        private string _CityProperty
        {
            get
            {
                Load(true);
                return Data.City;
            }
            set
            {
                if (Data.City!=value)
                {
                    Data.City=value;
                }
            }
        }

        /// <summary />
        private string _RegionProperty
        {
            get
            {
                Load(true);
                return Data.Region;
            }
            set
            {
                if (Data.Region!=value)
                {
                    Data.Region=value;
                }
            }
        }

        /// <summary />
        private string _PostalCodeProperty
        {
            get
            {
                Load(true);
                return Data.PostalCode;
            }
            set
            {
                if (Data.PostalCode!=value)
                {
                    Data.PostalCode=value;
                }
            }
        }

        /// <summary />
        private string _CountryProperty
        {
            get
            {
                Load(true);
                return Data.Country;
            }
            set
            {
                if (Data.Country!=value)
                {
                    Data.Country=value;
                }
            }
        }

        /// <summary />
        private string _PhoneProperty
        {
            get
            {
                Load(true);
                return Data.Phone;
            }
            set
            {
                if (Data.Phone!=value)
                {
                    Data.Phone=value;
                }
            }
        }

        /// <summary />
        private string _FaxProperty
        {
            get
            {
                Load(true);
                return Data.Fax;
            }
            set
            {
                if (Data.Fax!=value)
                {
                    Data.Fax=value;
                }
            }
        }

        /// <summary />
        private string _HomePageProperty
        {
            get
            {
                Load(true);
                return Data.HomePage;
            }
            set
            {
                if (Data.HomePage!=value)
                {
                    Data.HomePage=value;
                }
            }
        }


        /// <summary />
        public static readonly IdentityMap<Supplier.PrimaryKey, Supplier> IdentityMap=new IdentityMap<Supplier.PrimaryKey, Supplier>();

    }

}
