﻿// $Id: Supplier.cs 17434 2008-12-01 12:48:12Z unknown $
/*! \file
 * \brief Definition of Northwind.DomainModel.Supplier.
 *
 * \author $Author: unknown $
 * \date $Date: 2008-12-01 04:48:12 -0800 (周一, 01 十二月 2008) $
 * \version $Revision: 17434 $
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Xml.Serialization;
using Salamanca.DataAccess;
using Salamanca.DataAccess.Collections;
using Salamanca.DataRules;
#if (!NET_CF)
using System.Diagnostics.CodeAnalysis;
using System.Runtime.Serialization;
#endif

namespace Northwind.DomainModel
{



    ///////////////////////////////////////////////////////////////////////////
    ///
    /// <summary />
    ///
    ///////////////////////////////////////////////////////////////////////////

    public partial interface ISupplierContainer
    {
    }



    ///////////////////////////////////////////////////////////////////////////
    ///
    /// <summary />
    ///
    ///////////////////////////////////////////////////////////////////////////

    public partial interface ISupplierMapper:
        IDataMapper
    {
    }



    ///////////////////////////////////////////////////////////////////////////
    ///
    /// <summary />
    ///
    ///////////////////////////////////////////////////////////////////////////

#if (!NET_CF)
    [Serializable]
    [DataObject]
#endif
    public partial class Supplier:
        DomainEntity<Supplier.PrimaryKey, Supplier.DataTransfer>
    {

        /// <summary />
#if (!NET_CF)
        [SuppressMessage("Microsoft.Design", "CA1034:NestedTypesShouldNotBeVisible")]
#endif
        public partial class PrimaryKey:
            PrimaryKey<int>
        {

            /// <summary />
            public PrimaryKey():
                base()
            {
            }

            /// <summary />
            public PrimaryKey(int key):
                base(key)
            {
            }

        }

        /// <summary />
        [SoapType("SupplierData", "http://www.codeplex.com/salamanca/northwind/domainmodel/")]
        [XmlType("SupplierData", Namespace="http://www.codeplex.com/salamanca/northwind/domainmodel/")]
#if (!NET_CF)
        [Serializable]
        [SuppressMessage("Microsoft.Design", "CA1034:NestedTypesShouldNotBeVisible")]
#endif
        public partial class DataTransfer:
            IDataTransferObject
        {
        }

        /// <summary />
        public Supplier():
            base()
        {
        }

        /// <summary />
        public Supplier(DataMapperCollection dataMappers):
            base(dataMappers)
        {
        }

#if (!NET_CF)
        /// <summary />
        protected Supplier(SerializationInfo info, StreamingContext context):
            base(info, context)
        {
        }
#endif

        /// <summary />
        [StringLengthRule(40)]
        [NotNullRule]
#if (!NET_CF)
        [DataObjectField(false, false, false)]
#endif
        public string CompanyName
        {
            get
            {
                return _CompanyNameProperty;
            }
            set
            {
                if (_CompanyNameProperty!=value)
                {
                    _CompanyNameProperty=value;
                    RaisePropertyChanged("CompanyName");
                }
            }
        }

        /// <summary />
        [StringLengthRule(30)]
#if (!NET_CF)
        [DataObjectField(false, false, true)]
#endif
        public string ContactName
        {
            get
            {
                return _ContactNameProperty;
            }
            set
            {
                if (_ContactNameProperty!=value)
                {
                    _ContactNameProperty=value;
                    RaisePropertyChanged("ContactName");
                }
            }
        }

        /// <summary />
        [StringLengthRule(30)]
#if (!NET_CF)
        [DataObjectField(false, false, true)]
#endif
        public string ContactTitle
        {
            get
            {
                return _ContactTitleProperty;
            }
            set
            {
                if (_ContactTitleProperty!=value)
                {
                    _ContactTitleProperty=value;
                    RaisePropertyChanged("ContactTitle");
                }
            }
        }

        /// <summary />
        [StringLengthRule(60)]
#if (!NET_CF)
        [DataObjectField(false, false, true)]
#endif
        public string Address
        {
            get
            {
                return _AddressProperty;
            }
            set
            {
                if (_AddressProperty!=value)
                {
                    _AddressProperty=value;
                    RaisePropertyChanged("Address");
                }
            }
        }

        /// <summary />
        [StringLengthRule(15)]
#if (!NET_CF)
        [DataObjectField(false, false, true)]
#endif
        public string City
        {
            get
            {
                return _CityProperty;
            }
            set
            {
                if (_CityProperty!=value)
                {
                    _CityProperty=value;
                    RaisePropertyChanged("City");
                }
            }
        }

        /// <summary />
        [StringLengthRule(15)]
#if (!NET_CF)
        [DataObjectField(false, false, true)]
#endif
        public string Region
        {
            get
            {
                return _RegionProperty;
            }
            set
            {
                if (_RegionProperty!=value)
                {
                    _RegionProperty=value;
                    RaisePropertyChanged("Region");
                }
            }
        }

        /// <summary />
        [StringLengthRule(10)]
#if (!NET_CF)
        [DataObjectField(false, false, true)]
#endif
        public string PostalCode
        {
            get
            {
                return _PostalCodeProperty;
            }
            set
            {
                if (_PostalCodeProperty!=value)
                {
                    _PostalCodeProperty=value;
                    RaisePropertyChanged("PostalCode");
                }
            }
        }

        /// <summary />
        [StringLengthRule(15)]
#if (!NET_CF)
        [DataObjectField(false, false, true)]
#endif
        public string Country
        {
            get
            {
                return _CountryProperty;
            }
            set
            {
                if (_CountryProperty!=value)
                {
                    _CountryProperty=value;
                    RaisePropertyChanged("Country");
                }
            }
        }

        /// <summary />
        [StringLengthRule(24)]
#if (!NET_CF)
        [DataObjectField(false, false, true)]
#endif
        public string Phone
        {
            get
            {
                return _PhoneProperty;
            }
            set
            {
                if (_PhoneProperty!=value)
                {
                    _PhoneProperty=value;
                    RaisePropertyChanged("Phone");
                }
            }
        }

        /// <summary />
        [StringLengthRule(24)]
#if (!NET_CF)
        [DataObjectField(false, false, true)]
#endif
        public string Fax
        {
            get
            {
                return _FaxProperty;
            }
            set
            {
                if (_FaxProperty!=value)
                {
                    _FaxProperty=value;
                    RaisePropertyChanged("Fax");
                }
            }
        }

        /// <summary />
#if (!NET_CF)
        [DataObjectField(false, false, true)]
#endif
        public string HomePage
        {
            get
            {
                return _HomePageProperty;
            }
            set
            {
                if (_HomePageProperty!=value)
                {
                    _HomePageProperty=value;
                    RaisePropertyChanged("HomePage");
                }
            }
        }

    }
}
